window.onload = function () {
  // setTimeout("doRedirect()", 50);
  setTimeout(function () {
    serverReport('INVITE_URLCLICK', initClick);
  }, 10);
};

// serverReport('INVITE_URLCLICK'); 点击页面
// serverReport('INVITE_SKIPAPPSTORE'); 下载
function serverReport(type, fn) {
  var now = new Date();
  var tzOffset = now.getTimezoneOffset();
  $.ajax({
    contentType: 'application/json',
    type: 'POST',
    dataType: 'json',
    timeout: 5000,
    data: JSON.stringify({
      InviteKey: getParameterByName('i'),
      tzOffset: tzOffset,
      d: getParameterByName('d'),
      referer: document.referrer,
      pid: '0',
      language: navigator.language || navigator.userLanguage,
      userAgent: navigator.userAgent,
      url: encodeURIComponent(window.location.href),
      domain: window.location.host,
      requestTime: now.getTime(),
      eventType: type,
      deviceId: '',
      userId: '',
    }),
    url:
      'https://dt-apigateway-log.dt-pn1.com/dt-invite/retrieveInviter/retrieve',
    success: function () {
      fn && fn();
    },
    error: function () {
      fn && fn();
    },
    fail: function () {
      fn && fn();
    },
  });
}

// 获取链接参数
function getParameterByName(name, url) {
  if (!url) url = window.location.href;
  name = name.replace(/[\[\]]/g, '\\$&');
  var regex = new RegExp('[?&]' + name + '(=([^&#]*)|&|#|$)'),
    results = regex.exec(url);
  if (!results) return null;
  if (!results[2]) return '';
  return decodeURIComponent(results[2].replace(/\+/g, ' '));
}

// 覆盖IOS原有下载函数，新增跳转下载上报
if (window.open_appstore) {
  var ori_open_appstore = open_appstore;
  window.open_appstore = function () {
    serverReport('INVITE_SKIPAPPSTORE', ori_open_appstore);
  };
}
if (window.gotoAppStore) {
  var ori_gotoAppStore = gotoAppStore;
  window.gotoAppStore = function () {
    serverReport('INVITE_SKIPAPPSTORE', ori_open_appstore);
  };
}
// 覆盖android 原有下载函数，新增跳转上报
if (window.gotoPlayStore) {
  var ori_forwardgooglePlay = gotoPlayStore;
  window.gotoPlayStore = function () {
    serverReport('INVITE_SKIPAPPSTORE', ori_forwardgooglePlay);
  };
}

// 兼容剩余 android 跳转之前上报
function open_androidstore(from, inviteKey) {
  serverReport('INVITE_SKIPAPPSTORE', function () {
    if (!inviteKey) {
      inviteKey = '';
    }
    var link = getGooglePlayReferLinks2(from, inviteKey);
    window.location.href = link;
  });
}

// 直接跳转ios app store 兼容
function openAppStoreLinkReport(link) {
  serverReport('INVITE_SKIPAPPSTORE', function () {
    window.location.href = link;
  });
}
